100 REMark     ***************************************************
110 REMark 
120 REMark        Control Panel for SlowGold 1, by Dilwyn Jones
130 REMark 
140 REMark        (needs extensions in SLOWGOLD_bin installed.)
150 REMark 
160 REMark                 Written 20th December 1991
170 REMark 
180 REMark     ***************************************************
190 :
200 REMark $$asmb=flp1_QLIB_Ext,0,12
210 :
220 REMark find base of system variables
230 svbase = 163840                         : REMark on AH,JM,JS,MG
240 IF VER$ = 'JSL1' THEN svbase = VER$(-2) : REMark but on Minerva
250 sv_arbuf = svbase + 138 : REMark code of key pressed variable
260 wake_key = 254 : REMark SHIFT ENTER (CTRL ENTER on Thor 8)
270 audio% = 1 : REMark bleep when reading sv_arbuf
280 REMark do we need to change mode ?
290 IF (PEEK(svbase + 52) && 8) = 8 THEN MODE 4 : REMark yes, we do!
300 :
310 OPEN #3,'con' : REMark inner main console window
320 OPEN #4,'scr' : REMark outer, larger window
330 :
340 DIM fk%(7) : SET_DEFAULT_KEYS : REMark speed change keys
350 :
360 REPeat program
370   REMark draw display
380   SCREEN 50,14,0
390   BANNER 'SLOWGOLD 1 CONTROL PANEL',50
400   REPeat inner_loop
410     CLS #3 : REMark draw menu display
420     INK #3,4 : PRINT #3,\TO 9;'SLOWGOLD IS ';
430     IF SLOW_ON <> 0 THEN PRINT#3,'ON, ';:ELSE PRINT#3,'OFF,';:END IF 
440     PRINT #3,' VALUE SET IS ';HOW_SLOW : INK #3,7
450     PRINT #3,\TO 13;'0 - No slowdown (sleep)'
460     PRINT #3,TO 13;'1 - Go slow'
470     PRINT #3,TO 13;'2 - Set speed control keys'
480     PRINT #3,TO 13;'3 - Menu wake key set'
490     PRINT #3,TO 13;'4 - Value for slowgold'
500     PRINT #3,TO 12;'F4 - Redraw'
510     PRINT #3,TO 11;'ESC - Quit'
520     PRINT #3,\TO 11;'Press a key shown above : ';
530     :
540     Q_CURSON #3 : REMark wait for a valid key press
550     REPeat get_key
560       key = CODE (INKEY$(#3,-1))
570       SELect ON key = 48 TO 52,244,27,110,78,71,103,83,115,77,109,82,114,81,113,86,118:EXIT get_key
580     END REPeat get_key
590     Q_CURSOFF #3
600     :
610     REMark print indication of key pressed
620     SELect ON key
630       = 27,81,113  : PRINT #3,'<ESC>'
640       = 244,82,114 : PRINT #3,'<Redraw>'
650       = REMAINDER  : PRINT #3,CHR$(key)
660     END SELect 
670     :
680     REMark action key pressed
690     SELect ON key
700       = 27,81,113 : REMark Quit
710         CLS #3    : PRINT #3,'Quit - Are you sure Y/N ? ';
720         ASK_Y_OR_N : REMark returns result Y or N in variable "k$"
730         IF k$ == 'y' THEN EXIT program
740         CLS #3
750         :
760       = 244,82,114 : REMark refresh display
770         REMark do we need to change mode ?
780         IF (PEEK(svbase + 52) && 8) = 8 THEN MODE 4 : REMark yes !
790         EXIT inner_loop
800         :
810       = 48,78,110 : REMark NO_SLOW
820         CLS #3 : NO_SLOW
830         CLOSE #3 : CLOSE #4
840         REMark sleep until needed, i.e. re-awoken by wake_key
850         QP -1,1 : REMark very low priority (sleep)
860         REPeat get_key
870           IF PEEK_W(sv_arbuf) = wake_key THEN EXIT get_key
880         END REPeat get_key
890         QP -1,8 : REMark wake up again to normal speed
900         OPEN #3,'con' : OPEN #4,'scr'
910         EXIT inner_loop : REMark redraw display
920         :
930       = 51,77,109 : REMark Menu wake up key
940         CLS #3 : INK #3,4
950         PRINT #3,\TO 16;'SET MENU WAKE KEY' : INK #3,7
960         PRINT #3,\TO 7;'Press key you want to activate menu.'
970         PRINT #3,TO 15;'(e.g. SHIFT ENTER) ';
980         old_val = PEEK_W (sv_arbuf)
990         REPeat get_key
1000           wake_key = PEEK_W(sv_arbuf)
1010           IF wake_key <> old_val THEN EXIT get_key
1020         END REPeat get_key
1030         :
1040       = 52,86,118 : REMark Value for SLOW entered directly
1050         CLS #3 : Q_ERR_ON 'input'
1060         REPeat get_key
1070           INPUT #3,\'Enter slowdown value (0-31) : ';sl_val%
1080           IF Q_ERR = 0 THEN 
1090             IF sl_val% >= 0 AND sl_val% <= 31 THEN EXIT get_key
1100           END IF 
1110           BEEP 2000,50
1120         END REPeat get_key
1130         SLOW sl_val%
1140         Q_ERR_OFF
1150         :
1160       = 50,83,115 : REMark Set speed keys
1170         CLS #3 : INK #3,4
1180         PRINT #3,TO 15;'SET TOGGLE SLOW KEYS' : INK #3,7
1190         PRINT #3,\TO 14;'The default keys are:'
1200         PRINT #3,\'Slower: SHIFT ALT F1     Faster: SHIFT ALT F5'
1210         PRINT #3,\'CTRL SHIFT F1 = SLOW 0   CTRL SHIFT F2 = SLOW 8'
1220         PRINT #3,'CTRL SHIFT F3 = SLOW 16  CTRL SHIFT F4 = SLOW 24'
1230         PRINT #3,'CTRL SHIFT F5 = SLOW 31  Audio Beep is ';
1240         IF audio% THEN PRINT #3,'ON':ELSE PRINT #3,'OFF' : END IF 
1250         PRINT #3,\'Do you wish to use these keys Y/N ? ';
1260         ASK_Y_OR_N : REMark returns result Y or N in variable "k$"
1270         IF k$ == 'y' THEN 
1280           REMark use default keys
1290           SET_DEFAULT_KEYS
1300           NEXT inner_loop : REMark return to menu
1310         END IF 
1320         REMark user defines keys
1330         REMark user must be careful, as PANEL only 'listens' to
1340         REMark these keys and any other program 'hearing' them
1350         REMark will also react to them!
1360         CLS #3
1370         PRINT #3,'Press key for SLOW 0 : ';
1380         fk%(1) = GET_THE_KEY%
1390         PRINT #3,'Press key for SLOW 8 : ';
1400         fk%(2) = GET_THE_KEY%
1410         PRINT #3,'Press key for SLOW 16 : ';
1420         fk%(3) = GET_THE_KEY%
1430         PRINT #3,'Press key for SLOW 24 : ';
1440         fk%(4) = GET_THE_KEY%
1450         PRINT #3,'Press key for SLOW 31 : ';
1460         fk%(5) = GET_THE_KEY%
1470         PRINT #3,'Press key to decrease slow setting : ';
1480         fk%(6) = GET_THE_KEY%
1490         PRINT #3,'Press key to increase slow setting : ';
1500         fk%(6) = GET_THE_KEY%
1510         :
1520         PRINT #3,'Audible beep with these keypresses Y/N ? ';
1530         ASK_Y_OR_N : REMark returns result Y or N in variable "k$"
1540         IF k$ == 'y' THEN audio% = 1 : ELSE audio% = 0 : END IF 
1550         :
1560       = 49,71,103 : REMark Go slow
1570         CLS #3
1580         CLOSE #3 : CLOSE #4 : REMark put to sleep
1590         REMark previous_key = PEEK_W(sv_arbuf)
1600         QP -1,1 : REMark slow down to background
1610         GO_SLOW : REMark ensure it is really slowing down!
1620         REPeat loop
1630           previous_key = PEEK_W(sv_arbuf) : REMark last key pressed
1640           REMark monitor sv_arbuf for a recognised keypress
1650           REPeat loop2
1660             key = PEEK_W(sv_arbuf)
1670             IF key <> previous_key THEN 
1680               previous_key = key
1690               IF key = wake_key OR key = fk%(1) OR key = fk%(2) OR key = fk%(3) OR key = fk%(4) OR key = fk%(5) OR key = fk%(6) OR key = fk%(7) THEN EXIT loop2
1700             END IF :
1710           END REPeat loop2
1720           IF audio% THEN BEEP 200,10 : REMark audible key beep
1730           IF key = wake_key THEN 
1740             QP -1,8 : REMark speed me up a bit
1750             OPEN #3,'con' : OPEN #4,'scr'
1760             EXIT loop
1770           END IF 
1780           IF key = fk%(1) THEN SLOW 0
1790           IF key = fk%(2) THEN SLOW 8
1800           IF key = fk%(3) THEN SLOW 16
1810           IF key = fk%(4) THEN SLOW 24
1820           IF key = fk%(5) THEN SLOW 31
1830           IF key = fk%(6) THEN 
1840             REMark decrement SLOW setting
1850             loop = HOW_SLOW - 1 : IF loop < 0 THEN loop = 0
1860             SLOW loop
1870           END IF 
1880           IF key = fk%(7) THEN 
1890             REMark increment SLOW setting
1900             loop = HOW_SLOW + 1 : IF loop > 31 THEN loop = 31
1910             SLOW loop
1920           END IF 
1930         END REPeat loop
1940         EXIT inner_loop : REMark redraw menu display
1950         :
1960     END SELect 
1970   END REPeat inner_loop
1980 END REPeat program
1990 :
2000 REMark program finished
2010 CLS #3   : PRINT #3,'PROGRAM FINISHED.' : PAUSE 25
2020 CLOSE #3 : CLOSE #4 : REMark close window channels
2030 NO_SLOW : REMark turn off slow mode upon leaving
2040 STOP
2050 :
2060 DEFine PROCedure SCREEN (char_width%,char_height%,bottom_lines%)
2070   LOCal small_w%,small_h%,small_oy%,small_ox%
2080   LOCal big_w%,big_h%,big_ox%,big_oy%
2090   REMark define inner window first (CON window #3)
2100   REMark position it at the centre of the screen
2110   REMark window #3 and #4 must be open already
2120   small_w%  = (6 * char_width%) + 4
2130   small_h%  = (10 * char_height%) + 2
2140   small_ox% = (512 - small_w%) DIV 2
2150   small_oy% = (256 - small_h%) DIV 2
2160   IF (small_oy% MOD 2) = 1 THEN small_oy% = small_oy% - 1
2170   big_w%    = 2 + 2 + small_w% + 2 + 2
2180   big_ox%   = small_ox% - 4
2190   big_h%    = 1 + 15 + small_h% + (10 * bottom_lines%) + 1 + 1
2200   big_oy%   = small_oy% - 16
2210   WINDOW #4,big_w%,big_h%,big_ox%,big_oy%
2220   WINDOW #3,small_w%,small_h%,small_ox%,small_oy%
2230   BORDER #4,1,0 : PAPER #4,7 : INK #4,0 : CLS #4
2240   BLOCK  #4,big_w% - 16*6,15,8*6,0,4,7,1
2250   BORDER #3,1,4 : PAPER #3,0 : INK #3,7 : CLS #3
2260 END DEFine SCREEN
2270 :
2280 DEFine PROCedure BANNER (txt$,char_width%)
2290   LOCal txt_len%,txt_x%,t$(80)
2300   REMark positions a text heading at the top of window #4
2310   t$ = txt$ : IF t$ = '' THEN t$ = ' '
2320   IF t$(1) <> ' ' THEN t$ = ' ' & t$
2330   IF t$(LEN(t$)) <> ' ' THEN t$ = t$ & ' '
2340   txt_len% = LEN(t$)
2350   txt_x% = (((6 * char_width%) + 8) - (6 * LEN(t$))) DIV 2
2360   CURSOR #4,txt_x%,2 : PRINT #4,t$
2370 END DEFine BANNER
2380 :
2390 DEFine PROCedure SET_DEFAULT_KEYS
2400   REMark SLOW 0,8,16,24 and 32 set keys
2410   REMark these values are sv_arbuf values for these keys
2420   fk%(1) = 235 : fk%(2) = 239 : fk%(3) = 243 : fk%(4) = 247
2430   fk%(5) = 251
2440   fk%(6) = -5377 : REMark slowdown key
2450   fk%(7) = -1281 : REMark speed up key
2460 END DEFine SET_DEFAULT_KEYS
2470 :
2480 DEFine FuNction GET_THE_KEY%
2490   LOCal key,loop
2500   key = PEEK_W(sv_arbuf)
2510   REPeat loop
2520     loop = PEEK_W(sv_arbuf)
2530     IF loop <> key THEN key = loop : EXIT loop
2540   END REPeat loop
2550   PRINT #3,'OK' : RETurn key
2560 END DEFine GET_THE_KEY%
2570 :
2580 DEFine PROCedure ASK_Y_OR_N
2590   LOCal get_key
2600   REMark get a Yes or No response from user, print it to screen
2610   REMark return a "y" or "n" in the variable k$
2620   Q_CURSON #3
2630   REPeat get_key
2640     k$ = INKEY$(#3,-1)
2650     IF k$ INSTR 'yn' THEN EXIT get_key
2660   END REPeat get_key
2670   Q_CURSOFF #3
2680   PRINT #3,k$
2690 END DEFine ASK_Y_OR_N
